import sys, socket
import Pyro.naming, Pyro.core
try:
	import test_proxy
	print '*** Using static test_proxy.'
	dynproxy = 0
except ImportError:
	print '*** WARNING: no test_proxy found. Using dynamic proxy.'
	dynproxy = 1


Pyro.core.initClient()

locator = Pyro.naming.NameServerLocator()
print 'Searching Naming Service...',
try:
	ns = locator.getNS()
except (Pyro.core.PyroError,socket.error),x:
	import socket
	hn = socket.gethostname()
	print '\nNaming Service not found with broadcast. Trying host',hn,'...',
	ns = locator.getNS(host=hn)

print 'Naming Service found at',ns.URI.host,ns.URI.port

print 'binding to object'
try:
    URI=ns.resolve('test')
    print 'URI:',URI
except Pyro.core.PyroError,x:
    print 'Couldn\'t bind object, nameserver says:',x
    raise SystemExit


if dynproxy:
	# use dynamic proxy
	test = Pyro.core.getProxyForURI(URI)
else:
	# use static (precompiled) proxy
	test = test_proxy.testclass(URI)

    
print test.mul(111,9)
print test.add(100,222)
print test.sub(222,100)
print test.div(2.0,9.0)
print test.mul('*',10)
print test.add('String1','String2')
print '*** Now a server-generated exception should occur:'
print test.error()
